/*
 -------------------------------------------------------------------------
 Copyright (c) 2002-2006, XIMETA, Inc., FREMONT, CA, USA.
 All rights reserved.

 LICENSE TERMS

 The free distribution and use of this software in both source and binary 
 form is allowed (with or without changes) provided that:

   1. distributions of this source code include the above copyright 
      notice, this list of conditions and the following disclaimer;

   2. distributions in binary form include the above copyright
      notice, this list of conditions and the following disclaimer
      in the documentation and/or other associated materials;

   3. the copyright holder's name is not used to endorse products 
      built using this software without specific written permission. 
      
 ALTERNATIVELY, provided that this notice is retained in full, this product
 may be distributed under the terms of the GNU General Public License (GPL),
 in which case the provisions of the GPL apply INSTEAD OF those given above.
 
 DISCLAIMER

 This software is provided 'as is' with no explcit or implied warranties
 in respect of any properties, including, but not limited to, correctness 
 and fitness for purpose.
 -------------------------------------------------------------------------
*/

#include <linux/module.h> // EXPORT_NO_SYMBOLS, MODULE_LICENSE
#include <linux/version.h> // LINUX_VERSION_CODE, KERNEL_VERSION
#include <linux/init.h> // module_init, module_exit
#include <linux/netdevice.h> // dev_base dev_base_lock
#include <ndasuser/ndasuser.h>
#include <ndasuser/persist.h>
#include <ndasuser/io.h>
#include <ndasuser/write.h>
#include <ndasuser/bind.h>
#ifdef NDAS_MSHARE
#include <ndasuser/mediaop.h>
#endif//#ifdef NDAS_MSHARE
#include "linux_ver.h"

#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,10))
MODULE_LICENSE("Dual BSD/GPL");
#endif
MODULE_AUTHOR("Ximeta, Inc.");

// 
// NDAS emulator works only when NDAS library is built with NDAS_EMU defined.
//
int ndas_emu_init(void) 
{
#if 0
	int ret;

#if defined(_X86)
	ret = ndas_emu_start("/dev/hda", 1, 32);
#elif defined(_ARM)
	// This path is for envision board.
	ret = ndas_emu_start("/dev/discs/disc0/disc", 1, 32);
#else
	ret = ndas_emu_start("/dev/hda", 1, 32);
#endif

	if (ret) {
		if (NDAS_ERROR_UNSUPPORTED_SOFTWARE_VERSION == ret) {
			printk("ndas: NDAS binary is not built for NDAS emulator\n");
		} else {
			printk("ndas: failed to initailize emulator\n");
		}
		// Failed to load
		ndas_emu_stop();
		return -1;
	}
#endif    
    return 0;
}

void ndas_emu_exit(void) 
{    
#if 0
	ndas_emu_stop();
#endif
}

module_init(ndas_emu_init);
module_exit(ndas_emu_exit);

